# Class: Checkbox

## LuCI.ui. Checkbox

The `Checkbox` class implements a simple checkbox input field.

UI widget instances are usually not supposed to be created by view code directly, instead they're implicitely created by `LuCI.form` when instantiating CBI forms.

This class is automatically instantiated as part of `LuCI.ui`. To use it in views, use `'require ui'` and refer to `ui.Checkbox`. To import it in external JavaScript, use `L.require("ui").then(...)` and access the `Checkbox` property of the class instance value.

#### new LuCI.ui.Checkbox(value, options)

ui.js, line 533

  Instantiate a checkbox widget.

  Name | Type | Default | Description
  --- | --- | --- | ---
  `value` | string | null | optional The initial input value.
  `options` | LuCI.ui.Checkbox.InitOptions |  | optional Object describing the widget specific options to initialize the input.

### Extends

- LuCI.ui.AbstractElement

### Methods

#### inherited getValue(){string|Array.<string>|null}

ui.js, line 641

  Read the current value of the input widget.

  ##### Returns:

  Type | Description
  --- | ---
  string | Array.<string> | null | The current value of the input element. For simple inputs like text fields or selects, the return value type will be a - possibly empty - string. Complex widgets such as `DynamicList` instances may result in an array of strings or `null` for unset values.

#### inherited isChanged(){boolean}

ui.js, line 141

  Check whether the input value was altered by the user.

  ##### Returns:

  Type | Description
  --- | ---
  boolean | Returns `true` if the input value has been altered by the user or `false` if it is unchaged. Note that if the user modifies the initial value and changes it back to the original state, it is still reported as changed.

#### isChecked(){boolean}

ui.js, line 636

  Test whether the checkbox is currently checked.

  ##### Returns:

  Type | Description
  --- | ---
  boolean | Returns `true` when the checkbox is currently checked, otherwise `false`.

#### inherited isValid(){boolean}

ui.js, line 154

  Check whether the current input value is valid.

  ##### Returns:

  Type | Description
  --- | ---
  boolean | Returns `true` if the current input value is valid or `false` if it does not meet the validation constraints.

#### inherited registerEvents(targetNode, synevent, events)

ui.js, line 203

  Dispatch a custom (synthetic) event in response to received events.

  Sets up event handlers on the given target DOM node for the given event names that dispatch a custom event of the given type to the widget root DOM node.

  The primary purpose of this function is to set up a series of custom uniform standard events such as `widget-update`, `validation-success`, `validation-failure` etc. which are triggered by various different widget specific native DOM events.

  Name | Type | Description
  --- | --- | ---
  `targetNode` | Node | Specifies the DOM node on which the native event listeners should be registered.
  `synevent` | string | The name of the custom event to dispatch to the widget root DOM node.
  `events` | Array.<string> | The native DOM events for which event handlers should be registered.

#### inherited render(){Node}

ui.js, line 587

  Render the widget, setup event listeners and return resulting markup.

  ##### Returns:

  Type | Description
  --- | ---
  Node | Returns a DOM Node or DocumentFragment containing the rendered widget markup.

#### inherited setChangeEvents(targetNode, events)

ui.js, line 271

  Setup listeners for native DOM events that may change the widget value.

  Sets up event handlers on the given target DOM node for the given event names which may cause the input value to change completely, such as `change` events in a select menu. In contrast to update events, such change events will not trigger input value validation but they may cause field dependencies to get re-evaluated and will mark the input widget as dirty.

  Name | Type | Description
  --- | --- | ---
  `targetNode` | Node | Specifies the DOM node on which the event listeners should be registered.
  `events` | string | repeatable The DOM events for which event handlers should be registered.

#### inherited setPlaceholder(value)

ui.js, line 113

  Set the current placeholder value of the input widget.

  Name | Type | Description
  --- | --- | ---
  `value` | string | Array.<string> | null | The placeholder to set for the input element. Only applicable to text inputs, not to radio buttons, selects or similar.

#### inherited setUpdateEvents(targetNode, events)

ui.js, line 228

  Setup listeners for native DOM events that may update the widget value.

  Sets up event handlers on the given target DOM node for the given event names which may cause the input value to update, such as `keyup` or `onclick` events. In contrast to change events, such update events will trigger input value validation.

  Name | Type | Description
  --- | --- | ---
  `targetNode` | Node | Specifies the DOM node on which the event listeners should be registered.
  `events` | string | repeatable The DOM events for which event handlers should be registered.

#### inherited setValue(value)

ui.js, line 648

  Set the current value of the input widget.

  Name | Type | Description
  --- | --- | ---
  `value` | string | Array.<string> | null | The value to set the input element to. For simple inputs like text fields or selects, the value should be a - possibly empty - string. Complex widgets such as `DynamicList` instances may accept string array or `null` values.

#### inherited triggerValidation()

ui.js, line 168

  Force validation of the current input value.

  Usually input validation is automatically triggered by various DOM events bound to the input widget. In some cases it is required though to manually trigger validation runs, e.g. when programmatically altering values.

### Type Definitions

#### LuCI.ui.Checkbox.InitOptionsLuCI.ui.AbstractElement.InitOptions

  In addition to the `AbstractElement.InitOptions` the following properties are recognized:

  ##### Properties:

  Name | Type | Argument | Default | Description
  --- | --- | --- | --- | ---
  `value_enabled` | string | <optional> | 1 | Specifies the value corresponding to a checked checkbox.
  `value_disabled` | string | <optional> | 0 | Specifies the value corresponding to an unchecked checkbox.
  `hiddenname` | string | <optional> |  | Specifies the HTML `name` attribute of the hidden input backing the checkbox. This is a legacy property existing for compatibility reasons, it is required for HTML based form submissions.